/*
  Studienprojekt 2002:
  Register-Umsetzung nach XML
  Autor:   Heejung Park
  E-Mail: toheejung@web.de
*/

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.text.*;
import javax.swing.*;
import javax.swing.event.*;

  
public class DirectoryConverter
	extends JFrame
{
  static final String BOX_TITLE = "Filter Box";
  protected JFileChooser m_chooser;
  protected SimpleFilter m_xmlFilter;
  protected SimpleFilter m_rtfFilter;
  protected SimpleFilter m_csvFilter;
  protected JTextArea m_monitor;
  protected JSplitPane  m_sp;
  protected ImageIcon ii;
  protected String inputFilter;
  protected JDialog conversionDialog;

  private File rtfFile, metaFile, xmlFile, xmlSepFile;
  private String newLine;

	public DirectoryConverter()
	{
    super("RTF Directory Converter");
    newLine = System.getProperty("line.separator");
		setSize(650,500);

// Thomas Mann Picture
		ImageIcon ii = new ImageIcon("thomasmann.jpg");
		CustomScrollPane sp = new CustomScrollPane(new JLabel(ii));
    sp.setMinimumSize(new Dimension(650,400));

// Processing Log
    m_monitor = new JTextArea();
    m_monitor.append("<Processing Log>");
    m_monitor.setEditable(false);
    JScrollPane ps = new JScrollPane(m_monitor);

// Split pane with Thomas Mann Picture and Processing Log
    m_sp = new JSplitPane(JSplitPane.VERTICAL_SPLIT, sp, ps);
    m_sp.setContinuousLayout(false);
    m_sp.setOneTouchExpandable(true);
    getContentPane().add(m_sp, BorderLayout.CENTER);

// Filter fr File-Chooser     
    m_rtfFilter = new SimpleFilter("rtf", "RTF Documents");
    m_csvFilter = new SimpleFilter("csv", "CSV Documents");
    m_xmlFilter = new SimpleFilter("xml", "XML Documents");

// Men erzeugen
    JMenuBar menuBar = createMenuBar();
		setJMenuBar(menuBar);

		WindowListener wndCloser = new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				System.exit(0);
			}
		};
		addWindowListener(wndCloser);

    m_monitor.repaint();
		setVisible(true);
	}

  protected JMenuBar createMenuBar()
	{
		JMenuBar menuBar = new JMenuBar();

//  File-Men
		JMenu mFile = new JMenu("File");
		mFile.setMnemonic('f');

    JMenuItem mItem;
    ActionListener lst;

//  RTF Datei auswhlen (Verzeichnis-Datei)
    mItem = new JMenuItem("Select RTF File");
		mItem.setIcon(new ImageIcon("file_open.gif"));
		mItem.setMnemonic('r');
   	lst = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
        m_chooser = new JFileChooser();
		    m_chooser.setCurrentDirectory(new File("."));
        m_chooser.addChoosableFileFilter(m_rtfFilter);
        m_chooser.setFileFilter(m_rtfFilter);
        DirectoryConverter.this.repaint();
        if (m_chooser.showOpenDialog(DirectoryConverter.this) !=
					JFileChooser.APPROVE_OPTION)
					 return;
        Thread runner = new Thread() {
          public void run() {
			  	  rtfFile = m_chooser.getSelectedFile();
            System.out.println("User's original rtf file: "+rtfFile.getName());
            m_monitor.append(newLine+"RTF directory file: "+rtfFile.getName());
          }
        };
        runner.start();
			}
		};
		mItem.addActionListener(lst);
		mFile.add(mItem);


//  Metadaten-Datei auswhlen
		mItem = new JMenuItem("Select Meta Data File");
		mItem.setIcon(new ImageIcon("file_open.gif"));
		mItem.setMnemonic('m');
		lst = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{

        m_chooser = new JFileChooser();
		    m_chooser.setCurrentDirectory(new File("."));
        m_chooser.addChoosableFileFilter(m_csvFilter);
        m_chooser.setFileFilter(m_csvFilter);

        DirectoryConverter.this.repaint();
				if (m_chooser.showOpenDialog(DirectoryConverter.this) !=
					JFileChooser.APPROVE_OPTION)
					return;
        Thread runner = new Thread() {
          public void run() {
				    metaFile = m_chooser.getSelectedFile();
            System.out.println("User's meta data file: "+metaFile.getName());
            m_monitor.append(newLine+"Meta data file: "+metaFile.getName());
          }
        };
        runner.start();
			}
		};
		mItem.addActionListener(lst);
		mFile.add(mItem);

//  Leeres XML Dokument fr die Umsetzung erzeugen
		mItem = new JMenuItem("Create empty XML Document (Conversion)");
		mItem.setIcon(new ImageIcon("file_save.gif"));
		mItem.setMnemonic('d');
		lst = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
        m_chooser = new JFileChooser();
		    m_chooser.setCurrentDirectory(new File("."));
        m_chooser.addChoosableFileFilter(m_xmlFilter);
        m_chooser.setFileFilter(m_xmlFilter);

        DirectoryConverter.this.repaint();
      	if (m_chooser.showSaveDialog(DirectoryConverter.this) !=
					JFileChooser.APPROVE_OPTION)
					return;
        Thread runner = new Thread() {
          public void run() {
            File fChoosen = m_chooser.getSelectedFile();

            xmlFile = fChoosen;
            System.out.println("User's XML conversion file: "+xmlFile.getName());
            m_monitor.append(newLine+"New XML document: "+xmlFile.getName());
          }
        };
        runner.start();
			}
		};
		mItem.addActionListener(lst);
		mFile.add(mItem);

    mFile.addSeparator();

//  XML Dokument fr die Filterung auswhlen
    mItem = new JMenuItem("Select XML Document (Separation)");
		mItem.setIcon(new ImageIcon("file_open.gif"));
		mItem.setMnemonic('s');
		lst = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
        m_chooser = new JFileChooser();
		    m_chooser.setCurrentDirectory(new File("."));
        m_chooser.addChoosableFileFilter(m_xmlFilter);
        m_chooser.setFileFilter(m_xmlFilter);

        DirectoryConverter.this.repaint();
      	if (m_chooser.showOpenDialog(DirectoryConverter.this) !=
					JFileChooser.APPROVE_OPTION)
					return;
        Thread runner = new Thread() {
          public void run() {
            File fChoosen = m_chooser.getSelectedFile();

            xmlSepFile = fChoosen;
            System.out.println("User's XML separation file: "+xmlSepFile.getName());
            m_monitor.append(newLine+"XML document (separation): "+xmlSepFile.getName());
          }
        };
        runner.start();
			}
		};
		mItem.addActionListener(lst);
		mFile.add(mItem);

    mFile.addSeparator();


//  Filter auswhlen
		mItem = new JMenuItem("Filter Classes");
		mItem.setMnemonic('i');
		lst = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
        try {
          if (metaFile != null) {

//          Filter aus Metadaten-Datei erzeugen
            Vector filterList = new Vector(40);
            MetaTable metaTable = new MetaTable(metaFile);
            Collection values = metaTable.values();
            Iterator it = values.iterator();
            while (it.hasNext())
            {
              String s = (String) it.next();

              if (s != null) {
                StringTokenizer stringTokenizer = new StringTokenizer(s, "&;", false);
                if (stringTokenizer.hasMoreTokens()) {
                  String token = stringTokenizer.nextToken();
                  if (!filterList.contains(token))
                    filterList.addElement(token);
                }
              }
            }

            if (!filterList.isEmpty()) {
              Object[] plays = (Object[]) filterList.toArray();

//            Filterdialog aufbauen und anzeigen
				      inputFilter = (String)JOptionPane.showInputDialog(
					      DirectoryConverter.this,
					      "Please select a class for filtering",
					      BOX_TITLE, JOptionPane.INFORMATION_MESSAGE,
				  	    new ImageIcon("Books.gif"), plays,
				  	    "Werk");
				      System.out.println("User's filter input: "+inputFilter);
              m_monitor.append(newLine+"Selected filter: "+inputFilter);
            }
            else {
              m_monitor.append(newLine+"Filter error: Please check consistence of Meta Data File!");
            }
          }
          else {
            m_monitor.append(newLine+"Filter is missing: Please select Meta Data File!");
          }
        }
        catch (IOException ex)
				{
          m_monitor.append(newLine+"Filter error: Please check consistence of Meta Data Table! ");
          ex.printStackTrace();
				}


			}
		};
		mItem.addActionListener(lst);
		mFile.add(mItem);

		mFile.addSeparator();

//  Programm-Exit
		mItem = new JMenuItem("Exit");
		mItem.setMnemonic('x');
		lst = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				if (JOptionPane.showConfirmDialog(DirectoryConverter.this,
					"Do you want to quit this application ?",
					BOX_TITLE, JOptionPane.YES_NO_OPTION )
					== JOptionPane.YES_OPTION)
					System.exit(0);
			}
		};
		mItem.addActionListener(lst);
		mFile.add(mItem);
		menuBar.add(mFile);


//  Run-Men
    JMenu mRun = new JMenu("Run");
		mRun.setMnemonic('r');

//  Umsetzung RTF Verzeichnis nach XML
    JMenuItem entry = new JMenuItem("Convert RTF to XML...");
		entry.setMnemonic('c');
    lst = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
      	if (JOptionPane.showConfirmDialog(DirectoryConverter.this,
					"Do you want to start the conversion ?",
					"Start Conversion", JOptionPane.YES_NO_OPTION )
					== JOptionPane.YES_OPTION)  {

            if (rtfFile == null)
               m_monitor.append(newLine+"Conversion error: Please select RTF directory file! ");
            if (metaFile == null)
               m_monitor.append(newLine+"Conversion error: Please select Meta Data file! ");
            if (xmlFile == null)
               m_monitor.append(newLine+"Conversion error: Please select or create XML result document! ");

            if ((rtfFile != null) && (metaFile != null) && (xmlFile != null)) {
              Date now = new Date();
              DateFormat formatdt = DateFormat.getDateTimeInstance();

              try {
                m_monitor.append(newLine+">> "+formatdt.format(now)+"  Start Conversion... ");

//              Umsetzungsdialog aufbauen
                JOptionPane pane = new JOptionPane("Conversion is running... \n"+"Please wait!");
                pane.setIcon(new ImageIcon("Hamlet.gif"));
                Object[] options = new String[] {"Cancel"};
                pane.setOptions(options);
                conversionDialog = pane.createDialog(DirectoryConverter.this, "Conversion");

//              Starten der Umsetzung (Thread)
                Converter converter = new Converter(conversionDialog, m_monitor,
                                                    rtfFile, metaFile, xmlFile);
                converter.start();

//              Umsetzungsdialog anzeigen
                conversionDialog.show();
                Object obj = pane.getValue();
                if (options[0].equals(obj)) {
                  converter.interrupt();
                  now = new Date();
                  formatdt = DateFormat.getDateTimeInstance();
                  m_monitor.append(newLine+formatdt.format(now)+" Conversion canceled! ");
                }
              }
              catch (IOException ex){
                now = new Date();
                m_monitor.append(newLine+formatdt.format(now)+"Conversion Error: Please check restart program!");
					      ex.printStackTrace();
              }
            }
        }  //  if (JOptionPane...
			}
		};
    entry.addActionListener(lst);
    mRun.add(entry);

    mRun.addSeparator();

//  XML Dokument (Verzeichnis) filtern (nur erste Stufe)
    entry = new JMenuItem("Separate First Level with Filter...");
		entry.setMnemonic('f');

    lst = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				if (JOptionPane.showConfirmDialog(DirectoryConverter.this,
					"Do you want to start the separation ?",
					"Start Separation", JOptionPane.YES_NO_OPTION )
					== JOptionPane.YES_OPTION)  {

          Date now = new Date();
          DateFormat formatdt = DateFormat.getDateTimeInstance();

          try {
            m_monitor.append(newLine+">> "+formatdt.format(now)+"  Start Separation (first level)... ");

            if (inputFilter == null)
              m_monitor.append(newLine+"Separation Error: Please select filter class!");
            if (xmlSepFile == null)
              m_monitor.append(newLine+"Separation Error: Please select XML Document for separation!");
            if (metaFile == null)
              m_monitor.append("Separation Error: Please select Meta Data File!");

            if ((inputFilter != null) && (xmlSepFile != null) && (metaFile != null)) {
              MetaTable metaTable = new MetaTable(metaFile);
              String titleTag = metaTable.getTag("TITLE");
              if (titleTag == null)
                m_monitor.append("Separation Error: Key TITLE not found in Meta Data File!");
              else {
                Separator separator = new Separator(true, inputFilter, xmlSepFile, titleTag);
                now = new Date();
                m_monitor.append(newLine+formatdt.format(now)+"End Separation");
              }
            }
          }
          catch (IOException ex)
				  {
            now = new Date();
            m_monitor.append(newLine+formatdt.format(now)+"Separation Error: Please check original XML Document!");
					  ex.printStackTrace();
				  }
        }
			}
		};
    entry.addActionListener(lst);
    mRun.add(entry);

//  XML Dokument (Verzeichnis) filtern (alle Stufen)
    entry = new JMenuItem("Separate All Levels with Filter...");
		entry.setMnemonic('a');

    lst = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				if (JOptionPane.showConfirmDialog(DirectoryConverter.this,
					"Do you want to start the separation ?",
					"Start Separation", JOptionPane.YES_NO_OPTION )
					== JOptionPane.YES_OPTION)  {

          Date now = new Date();
          DateFormat formatdt = DateFormat.getDateTimeInstance();

          try {
            m_monitor.append(newLine+">> "+formatdt.format(now)+"  Start Separation (all levels)... ");

            if (inputFilter == null)
              m_monitor.append("Separation Error: Please select filter class!");
            if (xmlSepFile == null)
              m_monitor.append("Separation Error: Please select XML Document for separation!");
            if (metaFile == null)
              m_monitor.append("Separation Error: Please select Meta Data File!");

            if ((inputFilter != null) && (xmlSepFile != null) && (metaFile != null)) {
              MetaTable metaTable = new MetaTable(metaFile);
              String titleTag = metaTable.getTag("TITLE");
              if (titleTag == null)
                m_monitor.append("Separation Error: Key TITLE not found in Meta Data File!");
              else {
                Separator separator = new Separator(false, inputFilter, xmlSepFile, titleTag);
                now = new Date();
                m_monitor.append(newLine+formatdt.format(now)+"End Separation");
              }
            }
          }
          catch (IOException ex)
				  {
            now = new Date();
            m_monitor.append(newLine+formatdt.format(now)+"Separation Error: Please check original XML Document!");
					  ex.printStackTrace();
				  }
        }
			}
		};
    entry.addActionListener(lst);
    mRun.add(entry);

    menuBar.add(mRun);

//  Hilfe (About) anzeigen
    JMenu mHelp = new JMenu("Help");
		mHelp.setMnemonic('h');

    entry = new JMenuItem("About");
		entry.setMnemonic('a');
    lst = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
        String message = "RTF Directory Converter application \n"+
                         "Heejung Park, 2002 \n \n"+
                         "This program converts RTF directories \n"+
                         "to XML documents! ";
        JOptionPane.showMessageDialog(DirectoryConverter.this, message, "About RTF Directory Converter",
                                      JOptionPane.INFORMATION_MESSAGE);
      }
		};
    
    entry.addActionListener(lst);
		mHelp.add(entry);

    menuBar.add(mHelp);

		return menuBar;
	}


// Start Hauptprogramm 
  public static void main(String[] args)
	{
		new DirectoryConverter();
	}
}



class CustomScrollPane
	extends JPanel
{
	protected JScrollBar m_vertSB;
	protected JScrollBar m_horzSB;
	protected CustomViewport m_viewport;
	protected JComponent m_comp;

	public CustomScrollPane(JComponent comp)
	{
		setLayout(null);
		m_viewport = new CustomViewport();
		m_viewport.setLayout(null);
		add(m_viewport);
		m_comp = comp;
		m_viewport.add(m_comp);

		m_vertSB = new JScrollBar(JScrollBar.VERTICAL, 0, 0, 0, 0);
		m_vertSB.setUnitIncrement(5);
		add(m_vertSB);

		m_horzSB = new JScrollBar(JScrollBar.HORIZONTAL, 0, 0, 0, 0);
		m_horzSB.setUnitIncrement(5);
		add(m_horzSB);

		AdjustmentListener lst = new AdjustmentListener()
		{
			public void adjustmentValueChanged(AdjustmentEvent e)
			{
				m_viewport.doLayout();
			}
		};
		m_vertSB.addAdjustmentListener(lst);
		m_horzSB.addAdjustmentListener(lst);
	}

	public void doLayout()
	{
		Dimension d = getSize();
		Dimension d0 = m_comp.getPreferredSize();
		Dimension d1 = m_vertSB.getPreferredSize();
		Dimension d2 = m_horzSB.getPreferredSize();

		int w = Math.max(d.width - d1.width-1, 0);
		int h = Math.max(d.height - d2.height-1, 0);
		m_viewport.setBounds(0, 0, w, h);
		m_vertSB.setBounds(w+1, 0, d1.width, h);
		m_horzSB.setBounds(0, h+1, w, d2.height);

		int xs = Math.max(d0.width - w, 0);
		m_horzSB.setMaximum(xs);
		m_horzSB.setBlockIncrement(xs/5);
		m_horzSB.setEnabled(xs > 0);

		int ys = Math.max(d0.height - h, 0);
		m_vertSB.setMaximum(ys);
		m_vertSB.setBlockIncrement(ys/5);
		m_vertSB.setEnabled(ys > 0);

    m_horzSB.setVisibleAmount(m_horzSB.getBlockIncrement());
    m_vertSB.setVisibleAmount(m_vertSB.getBlockIncrement());
	}

	public Dimension getPreferredSize()
	{
		Dimension d0 = m_comp.getPreferredSize();
		Dimension d1 = m_vertSB.getPreferredSize();
		Dimension d2 = m_horzSB.getPreferredSize();
		Dimension d = new Dimension(d0.width+d1.width,
			d0.height+d2.height);
		return d;
	}

	class CustomViewport
		extends JPanel
	{
		public void doLayout()
		{
			Dimension d0 = m_comp.getPreferredSize();
			int x = m_horzSB.getValue();
			int y = m_vertSB.getValue();
			m_comp.setBounds(-x, -y, d0.width, d0.height);
		}
	}
}

class SimpleFilter extends javax.swing.filechooser.FileFilter
{
  private String m_description = null;
  private String m_extension = null;

  public SimpleFilter(String extension, String description) {
    m_description = description;
    m_extension = "."+extension.toLowerCase();
  }

  public String getDescription() {
    return m_description;
  }

  public boolean accept(File f) {
    if (f == null) 
      return false;
    if (f.isDirectory())
      return true;
    return f.getName().toLowerCase().endsWith(m_extension);
  }
}











